' PICBASIC PRO floating point include file

' Allocate storage for FP variables for 17Cxxx
'AARGB7  var     byte $18
'AARGB6  var     byte $19
AARGB5  var     byte $1a
AARGB4  var     byte $1b
AARGB3  var     byte $1c
AARGB2  var     byte $1d
aint    var     word $1e        ' Integer access to AARG
AARGB1  var     aint.byte0      ' $1e
AARGB0  var     aint.byte1      ' $1f
AEXP    var     byte $20
SIGN    var     byte $21
FPFLAGS var     byte $22
BARGB3  var     byte $23
BARGB2  var     byte $24
bint    var     word $25        ' Integer access to BARG
BARGB1  var     bint.byte0      ' $25
BARGB0  var     bint.byte1      ' $26
BEXP    var     byte $27
TEMPB3  var     byte $28
TEMPB2  var     byte $29
TEMPB1  var     byte $2a
TEMPB0  var     byte $2b

' Define floating point flags
IOV     var     FPFLAGS.0       ' bit0 = integer overflow flag
FOV     var     FPFLAGS.1       ' bit1 = floating point overflow flag
FUN     var     FPFLAGS.2       ' bit2 = floating point underflow flag
FDZ     var     FPFLAGS.3       ' bit3 = floating point divide by zero flag
NAN     var     FPFLAGS.4       ' bit4 = not-a-number exception flag
DOM     var     FPFLAGS.5       ' bit5 = domain error exception flag
RND     var     FPFLAGS.6       ' bit6 = floating point rounding flag, 0 = truncation
                                ' 1 = unbiased rounding to nearest LSB
SAT     var     FPFLAGS.7       ' bit7 = floating point saturate flag, 0 = terminate on
                                ' exception without saturation, 1 = terminate on
                                ' exception with saturation to appropriate value

        Goto skipfp     ' Skip past floating point library

' Floating point library must load at front
' Floating point routines are available in Microchip AN575
        asm
;        include "dev_fam.inc"
        include "math17.inc"
        include "fp24.a17"      ; For 24 bit fp library
        endasm

' Floating point addition
fpadd:
@       goto    FPA24   ; AARG = AARG + BARG

' Floating point subtract
fpsub:
@       goto    FPS24   ; AARG = AARG - BARG

' Floating point multiply
fpmul:
@       goto    FPM24   ; AARG = AARG * BARG

' Floating point divide
fpdiv:
@       goto    FPD24   ; AARG = AARG / BARG

' Convert int in aint to float in AARG
itofa:
@       goto    FLO1624 ; 16-bit int to 24-bit float

' Convert float in AARG to int in fpa
ftoia:
@       goto    INT2416 ; 24-bit float to 16-bit int

' Convert int in bint to float in BARG
itofb:
        Gosub   swapab  ' Can't convert in BARG so swap to AARG
        Gosub   itofa   ' 16-bit int to 24-bit float in a
'       Goto    swapab  ' Swap back (Fall through)

swapab: Swap AEXP, BEXP
        Swap AARGB0, BARGB0
        Swap AARGB1, BARGB1
        Swap AARGB2, BARGB2
        Return

skipfp: RND = 0         ' Rounding off
        SAT = 1         ' Saturation on
